package org.gcube.portlets.user.geoportaldataviewer.client.events.layers;

import org.gcube.portlets.user.geoportaldataviewer.shared.gis.BaseMapLayer;

import com.google.gwt.event.shared.GwtEvent;

/**
 * The Class ChangeBaseMapLayerEvent.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR francesco.mangiacrapa@isti.cnr.it
 * 
 *         Nov 12, 2021
 */
public class ChangeBaseMapLayerEvent extends GwtEvent<ChangeBaseMapLayerEventHandler> {
	public static Type<ChangeBaseMapLayerEventHandler> TYPE = new Type<ChangeBaseMapLayerEventHandler>();
	private BaseMapLayer baseMapLayer;

	/**
	 * Instantiates a new change map layer event.
	 *
	 * @param baseMapLayer the base map layer
	 */
	public ChangeBaseMapLayerEvent(BaseMapLayer baseMapLayer) {
		this.baseMapLayer = baseMapLayer;

	}

	/**
	 * Gets the associated type.
	 *
	 * @return the associated type
	 */
	@Override
	public Type<ChangeBaseMapLayerEventHandler> getAssociatedType() {
		return TYPE;
	}

	/**
	 * Dispatch.
	 *
	 * @param handler the handler
	 */
	@Override
	protected void dispatch(ChangeBaseMapLayerEventHandler handler) {
		handler.onChangeBaseMapLayer(this);

	}

	/**
	 * Gets the base map layer.
	 *
	 * @return the base map layer
	 */
	public BaseMapLayer getBaseMapLayer() {
		return baseMapLayer;
	}
}